#ifndef __MATT_DATATYPE__
#define __MATT_DATATYPE__
#ifdef UNIX
   #include <unistd.h>
#endif

#define MINUSONE ((DWORD)-1L)
typedef unsigned long DWORD;
typedef unsigned short WORD;
typedef unsigned char BYTE;
typedef signed long S_DWORD;
typedef signed short S_WORD;
typedef signed char S_BYTE;
typedef signed long INT32;
typedef signed short INT16;
typedef signed char INT8;
typedef unsigned long U_INT32;
typedef unsigned short U_INT16;
typedef unsigned char U_INT8;

  #define Get_Config_Info(xx) Get_Unix_Config_Info(xx)
#ifdef _WIN32
  typedef unsigned int ssize_t;
  typedef int BOOL;
  #define sockread(s,p,l) recv(s,(char *) p,l,0)

/* use SOCKWRITE !!!!! */
  #define sockwrite(s,p,l) send(s,(char *) p,l,0)
  #define SOCKCLOSE( s ) closesocket(s)
  #define strcasecmp(s,s1)  stricmp(s,s1)
  #define strncasecmp(s,s1,l)  strnicmp(s,s1,l)
#else
  typedef unsigned char BOOL;
#endif

#ifdef UNIX
  #define sockread(s,p,l) read(s,p,l)

/* use SOCKWRITE !!!!! */
  #define sockwrite(s,p,l) write(s,p,l)
  #define SOCKCLOSE( s ) close(s)
#endif /* UNIX */

#ifdef _MSDOS
#undef atoi
  #define atoi(s) atol(s)
  typedef sock_type SOK_T;
  typedef SOK_T *P_SOK_T;
  typedef unsigned int ssize_t;
  #define sockread(s,p,l) sock_fastread(s,(char *) p,l)

/* use SOCKWRITE !!!!! */
  #define sockwrite(s,p,l) sock_write(s,(char *) p,l)
  #define SOCKCLOSE( s ) sock_close(s)
  #define strcasecmp(s,s1)  stricmp(s,s1)
  #define strncasecmp(s,s1,l)  strnicmp(s,s1,l)

#endif

#ifdef _TSRMSDOS
    typedef int FD_T;
    #define STDIN 0
    #define STDOUT 1
    #define STDERR 2
 
    #define OPENWA(file) fdxopen(file,1,1)
    #define OPENR(file) fdxopen(file,0,0)
    #define OPENRW(file) fdxopen(file,2,0)
    #define OPENRWA(file) fdxopen(file,2,1)
    #define CLOSE(rcf) fdxclose(rcf)
    #define READCH(fd,buf) fdxreadch(buf,fd)
    #define WRITECH(fd,buf) fdxwritech(buf,fd)
    #define BAD_FILE NULL
    #define FD_EOF 0
#else
    typedef FILE *FD_T;
    #define STDIN stdin
    #define STDOUT stdout
    #define STDERR stderr
 
    #define OPENWA(file) fopen(file,"a")
    #define OPENR(file) fopen(file,"r")
    #define OPENRW(file) fopen(file,"r+")
    #define OPENRWA(file) fopen(file,"a+")
    #define CLOSE(rcf) fclose(rcf)
    #define READCH(fd,buf) *(buf) = fgetc(fd)
    #define WRITECH(fd,buf) fputc(*buf,fd)
    #define BAD_FILE NULL
    #define FD_EOF -1
#endif
#ifndef TRUE
  #define TRUE 1
#endif

#ifndef FALSE
  #define FALSE 0
#endif

#endif /* Matt's datatype */