;TEST = 1
	.8086
	.model small
	.code
	assume ds:nothing, es:nothing, ss:nothing
Label mods60 Word      ; Index/data pairs for 80x60
  DW 05404h	; start horiz retrace
  DW 08105h	; end horiz retrace
  DW 00b06h     ; Vertical Total (first 8 bits)
  DW 03e07h     ; Overflow (ninth/tenth bit Vertical Total)
  DW 04709h	; 8 rows/char
  DW 0ea10h     ; Vertical Retrace Start
  DW 0ac11h     ; Vertical Retrace End & (un)protect registers 0-7
  DW 0df12h     ; Vertical Display End
  DW 0e715h     ; Start Vertical Blank
  DW 00416h     ; End Vertical Blank
Label mods30 Word      ; Index/data pairs for 80x30
  DW 05404h	; start horiz retrace
  DW 08105h	; end horiz retrace
  DW 00b06h     ; Vertical Total (first 8 bits)
  DW 03e07h     ; Overflow (ninth/tenth bit Vertical Total)
  DW 04f09h	; 16 row/char
  DW 0ea10h     ; Vertical Retrace Start
  DW 0ac11h     ; Vertical Retrace End & (un)protect registers 0-7
  DW 0df12h     ; Vertical Display End
  DW 0e715h     ; Start Vertical Blank
  DW 00416h     ; End Vertical Blank

	public drawflags
DF_DRAWABLE = 1
DF_BOTTOM = 2
DF_60 = 4
DF_NOSPLIT = 8
biosvid		dd	?
drawflags	db	?
rows db ?
origin	db	?
color	db	14
curpos	dw	?
theircurpos dw	?
screen  dw	60*80 DUP (0e20h)
in10	db	0
hooked db 0
newgm proc far
; === Remove write protection ===
	mov     dx,03d4h
    mov     al,11h           ; VSync End contains write protect bit (bit 7)
    out     dx,al
    inc     dx               ; Crt Controller Data register
    in      al,dx
    and     al,01111111b     ; Remove write protect on various CrtC registers
    jmp $+2
    out     dx,al            ; (bit 7 is 0)


    xor     ax,ax        ; Empty ax
    mov     dx,03d4h     ; CrtC Register
    mov     cx,10        ; Number of entries
ParamLoop:
    lodsw                ; Load pair of index/data values into ax
    out     dx,ax        ; Out them to CrtC Register
    jmp $+2
    loop    ParamLoop
	ret
newgm ENDP
;
; now muddle with the CRTC to get 60 rows...
;
line60 proc far
	or	[drawflags],DF_60
	mov	si,offset mods60
	jmp 	newgm
line60 ENDP
line30 proc far
	mov	si,offset mods30
	jmp 	newgm
line30 ENDP

int10	proc far
	test	[in10],-1
	jnz	callbios
	test	[drawflags],DF_BOTTOM
	jz	int10x
	cmp	ah,0
	jnz	notms
	cmp	al,2
	jl	notours
	cmp	al,3
	ja	notours
	inc	[in10]
	pushf
	call	[biosvid]
	dec	[in10]
	mov	[drawflags],DF_DRAWABLE OR DF_BOTTOM
	mov	[theircurpos],0
	mov	[curpos],0
	
	push	ds
	push	si
	push	di
	push	dx
	push	cx
	pushf
	push	ax
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	cx,80*50
	mov	di,offset screen
	mov	ax,0e20h
	rep	stosw
	call	line30
	pop	ax
	popf
	pop	cx
	pop	dx
	pop	di
	pop	si
	pop	ds
int10x:
	iret

notours:
	mov	[drawflags],0
callbios:
	jmp	[biosvid]

notms:
	cmp	ax,1112h
	jnz	callbios
	test	[drawflags],DF_DRAWABLE
	jz	callbios
	inc	[in10]
	pushf
	call	[biosvid]
	dec	[in10]
	push	ds
	push	si
	push	di
	push	dx
	push	cx
	pushf
	push	ax
	mov	ax,cs
	mov	ds,ax
	call	line60
	pop	ax
	popf
	pop	cx
	pop	dx
	pop	di
	pop	si
	pop	ds
	iret
int10	endp
screenrows	proc far
	sub	ax,ax
	test	[drawflags],DF_NOSPLIT
	jnz	scnobot
	mov	ax,5
scnobot:
	mov	cx,25
	test	[drawflags],DF_60
	jz	not60
	add	cx,cx
	add	ax,ax
not60:
	ret
screenrows ENDP
calcurpos	proc far
	mov	dx,[curpos]
	mov	al,dh
	add	al,[origin]
	mov	dh,160
	mul	dh
	sub	dh,dh
	add	ax,dx
	add	ax,dx
	mov	bx,ax
	test	[drawflags],DF_NOSPLIT
	jz	cconscreen
	test	[drawflags],DF_BOTTOM
	jz	cconscreen
	add	bx,offset screen
cconscreen:
	ret
calcurpos	ENDP
outlf	proc far
	cld
	mov	byte ptr [curpos],0
	mov	al,[rows]
	dec	al
	cmp	byte ptr [curpos+1],al
	jc	outlfir
	test	[drawflags],DF_NOSPLIT
	jz	notnosplit
	test	[drawflags],DF_BOTTOM
	jz	notnosplit
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	si,offset screen+160
	mov	di,offset screen
	mov	al,[origin]
	dec	al
	mov	ah,80
	mul	ah
	mov	cx,ax
	rep	movsw
	mov	ax,0720h
	mov	cx,80
	rep	stosw
	ret
outlfir:
	inc	byte ptr [curpos+1]
	ret

notnosplit:
	push	ds
	push	es

	test	[drawflags],DF_BOTTOM
	jz	onlyscroll
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	si,offset screen+160
	mov	di,offset screen
	mov	al,[origin]
	dec	al
	mov	ah,80
	mul	ah
	mov	cx,ax
	rep	movsw

	mov	ax,0b800h
	mov	ds,ax
	sub	si,offset screen
	mov	cx,80
	rep	movsw
	
onlyscroll:
	mov	ax,0b800h
	mov	ds,ax
	mov	es,ax
	mov	al,[origin]
	mov	ah,160
	mul	ah
	mov	di,ax
	add	ax,160
	mov	si,ax
	mov	al,[rows]
	dec	al
	mov	ah,160
	mul	ah
	mov	cx,ax
	rep	movsw

	mov	ax,0720h
	mov	cx,80
	rep	stosw

	pop	es
	pop	ds
	ret
outlf	ENDP
outch	proc far
	push	ax
	call	calcurpos
	pop	ax
	mov	ah,[color]
	mov	es:[bx],ax
	inc	[curpos]
	cmp	byte ptr [curpos],80
	jc	outchx
	push	si
	call	outlf
	pop	si
outchx:
	ret
outch	ENDP
drawstring proc far
	lodsb
	or	al,al
	jz	dsx
	test	al,80h
	jz	nocolor
	and	al,7fh
	mov	[color],al
	jmp 	drawstring
nocolor:
	cmp	al,13
	jnz	no13
	mov	byte ptr [curpos],0
	jmp	drawstring
no13:
	cmp	al,10
	jnz	no10
	push	si
	call	outlf
	pop	si
	jmp	drawstring
no10:
	cmp	al,9
	jnz	no9
tabl:
	mov	al,20h
	call	outch
	mov	al,byte ptr [curpos]
	and	al,7
	cmp	al,7
	jz	drawstring
	jmp	tabl

no9:
	cmp	al,7
	jnz	no7
	mov	ah,14
	pushf
	call	biosvid
	jmp	drawstring
no7:
    	cmp	al,8
	jnz	no8
	dec	byte ptr [curpos]
	jge	c8x
	mov	[curpos],79
	dec	byte ptr [curpos + 1]
	jge	c8x
	inc	byte ptr [curpos+1]
c8x:
	jmp	drawstring
no8:
	cmp	al,20h
	jc	drawstring
	call	outch
	jmp	drawstring
dsx:
drawstring ENDP
	

recurs PROC far
	test	[drawflags],DF_BOTTOM
	jnz	nocset
	call	calcurpos
	shr	bx,1
	mov	dx,3d4h
	mov	al,0eh			; Cursor pos hi register 
	mov	ah,bh			; cursor pos hi byte
	out	dx,ax			; Out the high byte
	inc	al			; Cursor pos lo register
	mov	ah,bl			; cursor pos lo byte
	out	dx,ax			; out the lo byte
nocset:
	ret
recurs ENDP
	public _reset_video
_reset_video PROC far
	mov	ax,3
	int	10h
	ret
_reset_video ENDP
	public _hook10
_hook10	proc far
	push	bp
	mov	bp,sp
	sub	ax,ax
	mov	es,ax
	mov	ax,es:[10h*4]
	mov	word ptr [biosvid],ax
	mov	ax,es:[10h*4+2]
	mov	word ptr [biosvid+2],ax
	mov	al,[bp+6]	; VGA flag
	mov	ah,[bp+8]	; hook flag
	and	ah,al
	jz	nonhook
	push	ax
	cli
	mov	ax,offset int10
	mov	word ptr es:[10h*4],ax
	mov	word ptr es:[10h*4+2],cs
	sti
	mov	ax,3
	or	[drawflags],DF_BOTTOM
	int	10h
	mov	[hooked],1
	pop	ax
nonhook:
	or	[drawflags],DF_BOTTOM
	or	al,al
	jnz	splitscr
	or	[drawflags],DF_DRAWABLE OR DF_NOSPLIT
	test	byte ptr [bp+8],-1
	jz	nosplitnohook
	call	_drawtop
	mov	[curpos],0
	pop	bp
	ret
nosplitnohook:
	mov	ax,300h
	mov	bh,0
	int	10h
	push	dx
	call	_drawtop
	pop	[curpos]
	pop	bp
	ret
splitscr:
	call	_drawtop
	pop	bp
	ret
_hook10	ENDP
	public	_unhook10
_unhook10 proc far
	test	[hooked],-1
	jz	nounhook
	mov	[hooked],0
	sub	ax,ax
	mov	es,ax
	cli
	mov	ax,word ptr [biosvid]
	mov	es:[10h*4],ax
	mov	ax,word ptr [biosvid+2]
	mov	es:[10h*4+2],ax
	sti
	call	_drawtop
nounhook:
	mov	dx,[curpos]
	mov	ah,2
	int	10h
	ret
_unhook10 ENDP
	public hook10unhookable
hook10unhookable proc far
	test	[hooked],-1
	jz	nounhookable
	mov	[hooked],0
	sub	ax,ax
	mov	es,ax
	mov	ax,word ptr [biosvid]
	cmp	es:[10h*4],ax
	jnz	nounhookable
	mov	ax,word ptr [biosvid+2]
	cmp	es:[10h*4+2],ax
nounhookable:
	ret
hook10unhookable ENDP
	public	_drawbottom
_drawbottom proc far
	call	screenrows
	mov	[rows],al
	mov	[origin],cl
	
	sub	byte ptr [curpos+1],cl
	jc	dbc
	cmp	al,byte ptr [curpos+1]
	jnc	dbnc
dbc:
	dec	al
	mov	byte ptr [curpos],al
dbnc:
	or	[drawflags],DF_BOTTOM
	mov	dx,[theircurpos]
	mov	ah,2
	sub	bh,bh
	pushf
	call	[biosvid]
	ret
_drawbottom ENDP
	public	_drawtop
_drawtop proc far
	call	screenrows
	add	ax,cx
	mov	[rows],al
	add	byte ptr [curpos+1],cl
	mov	[origin],0
	and	[drawflags],NOT DF_BOTTOM
	mov	ah,3
	sub	bh,bh
	pushf
	call	[biosvid]
	mov	[theircurpos],dx
	call	recurs
	ret
_drawtop ENDP
	public	_swapscreen
_swapscreen proc far
	push	si
	push	di
	push	ds
	push	es
	mov	ax,0b800h
	mov	ds,ax
	mov	ax,cs
	mov	es,ax
	mov	cx,25*80
	test	[drawflags],DF_60
	jz	ss25
	shl	cx,1
ss25:
	sub	si,si
	mov	di,offset screen
ssl:
	lodsw
	xchg	ax,es:[di]
	mov	ds:[si-2],ax
	add	di,2
	loop	ssl
	pop	es
	pop	ds
	pop	di
	pop	si
	ret
_swapscreen ENDP
	public	_draw
_draw	proc far
	test	[drawflags],DF_BOTTOM
	jz	okdraw
	test	[drawflags],DF_DRAWABLE
	jz	nodraw

okdraw:
	push	bp
	mov	bp,sp
	push	si
	push	ds
	push	bx
	lds	si,[bp+6]
	test	[drawflags],DF_NOSPLIT
	jz	onscreen
	test	[drawflags],DF_BOTTOM
	jz	onscreen
	mov	ax,cs
	mov	es,ax
	jmp	dsg
onscreen:
	mov	ax,0b800h
	mov	es,ax
dsg:
	call	drawstring
	pop	bx
	pop	ds
	pop	si
	pop	bp
nodraw:
	ret
_draw	ENDP

	end