	.8086
	.model small
	extrn _drawbottom : far, _drawtop : far
	extrn _swapscreen : far
	extrn ourcontext : far, theircontext : far
	.code
	assume ds:nothing, es:nothing, ss:nothing
	extrn drawflags : byte

	public tsrbusy
TICKWAIT = 4    ; approximately every 1/5th second
DF_DRAWABLE = 1
DF_BOTTOM = 2
DF_60 = 4
DF_NOSPLIT = 8
biosmulti	dd	?
biostime	dd	?
bioskey		dd	?
delaycount db	TICKWAIT
tsrbusy	db	?
installed db	?
int15	proc far
	pushf
	test	[drawflags],DF_DRAWABLE
	jz	int15ch
	cmp	ax,4f0fh		; tab keyh
	jnz	int15ch
	push	ds
	push	ax
	mov	ax,40h
	mov	ds,ax
	test	byte ptr ds:[17h],8	; alt key
	pop	ax
	pop	ds
	jz	int15ch	
	popf
	push	bp
	mov	bp,sp
	and	byte ptr [bp+6],0feh
	pop	bp
	push	ax
	push	bx
	push	cx
	push	dx
	test	[drawflags],DF_BOTTOM
	jnz	swtotop
	call	_drawbottom
	jmp	int15x
swtotop:
	call	_drawtop
int15x:	
	call	_swapscreen
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	iret

int15ch:
	popf
	jmp	[biosmulti]
	
int15	ENDP
doupcall proc near
	inc	[tsrbusy]
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	ds
	push	es
	call	ourcontext
	mov	ax,@data
	mov	ds,ax
	mov	ax,0
	push	ax
	extrn _upcall : far
ducl:
	call	_upcall
	test	[installed],-1
	jz	dux
	test	[drawflags],DF_BOTTOM
	jz	ducl
dux:
	pop	cx
	call	theircontext
	pop	es
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	dec	[tsrbusy]
	ret
doupcall ENDP
int16	PROC
	or	ah,ah
	jz	func0
	cmp	ah,10h
	jz	func10
	test	[drawflags],DF_BOTTOM
	jnz	int16ch
	cmp	ah,1
	jz	retz
	cmp	ah,11h
	jnz	int16ch
retz:
	push	bp
	mov	bp,sp
	or	byte ptr [bp+6],40h	; set zero flag
	pop	bp
	iret
func0:
	push	ax
	sti
func0l:
	test	[drawflags],DF_BOTTOM
	jz	nodos0
	mov	ah,1
	pushf
	call	[bioskey]
	jnz	int16ch2
nodos0:
	test	[installed],-1
	jz	int16ch2
	call	doupcall
	jmp	func0l
	
int16ch2:
	pop	ax
int16ch:
	jmp	[bioskey]
func10:
	push	ax
	sti
func10l:
	test	[drawflags],DF_BOTTOM
	jz	nodos10
	mov	ah,11h
	pushf
	call	[bioskey]
	jnz	int16ch2
nodos10:
	test	[installed],-1
	jz	int16ch2
	call	doupcall
	jmp	func10l

int16	ENDP
int8	proc far
	push	ds
	push	ax
	mov	ax,@data
	mov	ds,ax
	extrn	_tickcall : far
	call	_tickcall
	pop	ax
	pop	ds
	
	test	[tsrbusy],-1
	jnz	int8ch
	test	[drawflags],DF_BOTTOM
	jz	godo
	dec	[delaycount]
	jnz	int8ch
godo:
	inc	[tsrbusy]
	mov	[delaycount],TICKWAIT
	pushf
	call	[biostime]
	sti
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	ds
	push	es
	call	ourcontext
	mov	ax,@data
	mov	ds,ax
	mov	ax,0
	push	ax
	extrn _upcall : far
	call	_upcall
	pop	cx
	call	theircontext
	pop	es
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	dec	[tsrbusy]
	iret

int8ch:
	jmp	[biostime]

int8	ENDP
	public _getkey
_getkey proc far
	sub	ax,ax
	test	[drawflags],DF_BOTTOM
	jnz	nokey
	mov	ah,1
	pushf
	call	[bioskey]
	mov	ax,0
	jz	nokey
	sub	ah,ah
	pushf
	call	[bioskey]
	sub	ah,ah
nokey:
	ret
_getkey ENDP
	public _hook8
_hook8 proc far
	sub	ax,ax
	mov	es,ax
	mov	ax,es:[15h*4]
	mov	word ptr [biosmulti],ax
	mov	ax,es:[15h*4+2]
	mov	word ptr [biosmulti+2],ax
	mov	ax,es:[8h*4]
	mov	word ptr [biostime],ax
	mov	ax,es:[8h*4+2]
	mov	word ptr [biostime+2],ax
	mov	ax,es:[16h*4]
	mov	word ptr [bioskey],ax
	mov	ax,es:[16h*4+2]
	mov	word ptr [bioskey+2],ax
	push	bp
	mov	bp,sp
	mov	al,[bp+6]
	pop	bp
	or	al,al
	jz	_hook8not
	cli
	mov	ax,offset int15
	mov	word ptr es:[15h*4],ax
	mov	word ptr es:[15h*4+2],cs
	mov	ax,offset int8
	mov	word ptr es:[8h*4],ax
	mov	word ptr es:[8h*4+2],cs
	mov	ax,offset int16
	mov	word ptr es:[16h*4],ax
	mov	word ptr es:[16h*4+2],cs
	mov	[installed],1
	sti
_hook8not:
	ret
_hook8	ENDP
	public	_unhook8
_unhook8 proc far 
	sub	ax,ax
	mov	es,ax
	mov	[installed],0
	cli
	mov	ax,word ptr [biosmulti]
	mov	es:[15h*4],ax
	mov	ax,word ptr [biosmulti+2]
	mov	es:[15h*4+2],ax
	mov	ax,word ptr [biostime]
	mov	es:[8h*4],ax
	mov	ax,word ptr [biostime+2]
	mov	es:[8h*4+2],ax
	mov	ax,word ptr [bioskey]
	mov	es:[16h*4],ax
	mov	ax,word ptr [bioskey+2]
	mov	es:[16h*4+2],ax
	sti
	ret
_unhook8 ENDP
	public	hook8unhookable
hook8unhookable proc far 
	sub	ax,ax
	mov	es,ax
	mov	ax,word ptr [biosmulti]
	cmp	es:[15h*4],ax
	jnz	notunhook
	mov	ax,word ptr [biosmulti+2]
	cmp	es:[15h*4+2],ax
	jnz	notunhook
	mov	ax,word ptr [biostime]
	cmp	es:[8h*4],ax
	jnz	notunhook
	mov	ax,word ptr [biostime+2]
	cmp	es:[8h*4+2],ax
	jnz	notunhook
	mov	ax,word ptr [bioskey]
	cmp	es:[16h*4],ax
	jnz	notunhook
	mov	ax,word ptr [bioskey+2]
	cmp	es:[16h*4+2],ax
notunhook:
	ret
hook8unhookable ENDP

	end